
package de.ivu.elect.business.system.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.system.entity.SystemLog;

@RequestScoped
@Named(SystemLogConversationSelect.COMPONENT_NAME)
public class SystemLogConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "systemLogConversationSelect";

  @Inject
  protected transient SystemLogExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(SystemLogConversationStore.class)
  protected transient SystemLogConversationStore conversationStore;

  public SystemLogConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public SystemLog getEntity() {
    return getEntityInternal();
  }

  private SystemLog getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(SystemLog entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.system.entity.SystemLogPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(SystemLog entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.system.entity.SystemLogPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.system.entity.SystemLogPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected SystemLog attach(SystemLog entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected SystemLog attach( de.ivu.elect.business.system.entity.SystemLogPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
